/*Web: http://www.buydisplay.com
EastRising Technology Co.,LTD
Examples for ER-EPD042-1B
Display is Hardward SPI 4-Wire SPI Interface 
Tested and worked with:
Works with Arduino 1.6.0 IDE  
Works with Arduino DUE,Arduino mega2560,Arduino UNO Board
****************************************************/
#include "ER-EPD042-1B.h"
#include "GUI_Paint.h"
#include "EPD_SDCard.h"
#include "ImageData.h"
#include <Wire.h>
#include <SPI.h>
#include <SD.h>

void setup()
{
    GUIPAINT paint;
    EPD4IN2 epd;
    EPD_SDCARD SD;
    
    //Initialize e-Paper
    if (epd.EPD_Init() != 0) {
        Serial.print("e-Paper init failed");
        return;
    }
    epd.EPD_Clear();
    Serial.print("4.2inch e-Paper demo\n");

#if 1
    //1.Initialize the SD card
    SD.SDCard_Init();
    
    //2.Create a new image cache named IMAGE_BW and fill it with white
    paint.Paint_NewImage(IMAGE_BW, EPD_WIDTH, EPD_HEIGHT, IMAGE_ROTATE_0, IMAGE_COLOR_INVERTED);
    paint.Paint_Clear(WHITE);       
    //3.Read BMP pictures into RAM, IMAGE_ROTATE_0 will not affect reading
    SD.SDCard_ReadBMP("042-1b1.bmp", 0, 0);    
    //4.Refresh the picture in RAM to e-Paper
    epd.EPD_Display();
    Dev->Dev_Delay_ms(2000);
    
     //2.Create a new image cache named IMAGE_BW and fill it with white
    paint.Paint_NewImage(IMAGE_BW, EPD_WIDTH, EPD_HEIGHT, IMAGE_ROTATE_0, IMAGE_COLOR_POSITIVE);
    paint.Paint_Clear(WHITE);       
    //3.Read BMP pictures into RAM, IMAGE_ROTATE_0 will not affect reading
    SD.SDCard_ReadBMP("042-1b1.bmp", 0, 0);    
    //4.Refresh the picture in RAM to e-Paper
    epd.EPD_Display();
    Dev->Dev_Delay_ms(2000);  
    
     //2.Create a new image cache named IMAGE_BW and fill it with white
    paint.Paint_NewImage(IMAGE_BW, EPD_WIDTH, EPD_HEIGHT, IMAGE_ROTATE_0, IMAGE_COLOR_INVERTED);
    paint.Paint_Clear(WHITE);       
    //3.Read BMP pictures into RAM, IMAGE_ROTATE_0 will not affect reading
    SD.SDCard_ReadBMP("042-1b2.bmp", 0, 0);    
    //4.Refresh the picture in RAM to e-Paper
    epd.EPD_Display();
    Dev->Dev_Delay_ms(2000);
    
      //2.Create a new image cache named IMAGE_BW and fill it with white
    paint.Paint_NewImage(IMAGE_BW, EPD_WIDTH, EPD_HEIGHT, IMAGE_ROTATE_0, IMAGE_COLOR_POSITIVE);
    paint.Paint_Clear(WHITE);       
    //3.Read BMP pictures into RAM, IMAGE_ROTATE_0 will not affect reading
    SD.SDCard_ReadBMP("042-1b2.bmp", 0, 0);    
    //4.Refresh the picture in RAM to e-Paper
    epd.EPD_Display();
    Dev->Dev_Delay_ms(2000);   
    
       
 #endif   
//#elif 1
#if 0
    //1.Create a new image cache named IMAGE_BW and fill it with white
    paint.Paint_NewImage(IMAGE_BW, EPD_WIDTH, EPD_HEIGHT, IMAGE_ROTATE_0, IMAGE_COLOR_POSITIVE);
    
    //2.show image for array, IMAGE_ROTATE_0 and IMAGE_COLOR_POSITIVE will not affect reading
    paint.Paint_DrawBitMap(IMAGE_DATA);
    
    //3.Refresh the picture in RAM to e-Paper
    epd.EPD_Display();
    Dev->Dev_Delay_ms(2000);
#endif

#if 0
    //1.Create a new image cache named IMAGE_BW and fill it with white
    paint.Paint_NewImage(IMAGE_BW, EPD_WIDTH, EPD_HEIGHT, IMAGE_ROTATE_0, IMAGE_COLOR_POSITIVE);
    paint.Paint_Clear(WHITE);
    
    //2.Drawing on the image
    paint.Paint_DrawPoint(10, 20, BLACK, DOT_PIXEL_1X1, DOT_STYLE_DFT);
    paint.Paint_DrawPoint(10, 30, BLACK, DOT_PIXEL_2X2, DOT_STYLE_DFT);
    paint.Paint_DrawPoint(10, 40, BLACK, DOT_PIXEL_3X3, DOT_STYLE_DFT);
    paint.Paint_DrawPoint(10, 50, BLACK, DOT_PIXEL_4X4, DOT_STYLE_DFT);

    paint.Paint_DrawLine(20, 20, 70, 70, BLACK, LINE_STYLE_SOLID, DOT_PIXEL_1X1);
    paint.Paint_DrawLine(70, 20, 20, 70, BLACK, LINE_STYLE_SOLID, DOT_PIXEL_1X1);
    paint.Paint_DrawLine(30, 120, 60, 120, BLACK, LINE_STYLE_DOTTED, DOT_PIXEL_1X1);
    paint.Paint_DrawLine(45, 135, 45, 105, BLACK, LINE_STYLE_DOTTED, DOT_PIXEL_1X1);

    paint.Paint_DrawRectangle(20, 20, 70, 70, BLACK, DRAW_FILL_EMPTY, DOT_PIXEL_1X1);
    paint.Paint_DrawRectangle(75, 20, 120, 70, BLACK, DRAW_FILL_FULL, DOT_PIXEL_1X1);

    paint.Paint_DrawCircle(45, 120, 15, BLACK, DRAW_FILL_EMPTY, DOT_PIXEL_1X1);
    paint.Paint_DrawCircle(100, 120, 15, BLACK, DRAW_FILL_FULL, DOT_PIXEL_1X1);

    paint.Paint_DrawString_EN(10, 150, "hello world", &Font12, WHITE, BLACK);
    paint.Paint_DrawString_EN(10, 170, "www,buydisplay.com", &Font16, BLACK, WHITE);

    paint.Paint_DrawNum(10, 200, 123456789, &Font12, BLACK, WHITE);
    paint.Paint_DrawNum(10, 220, 987654321, &Font16, WHITE, BLACK);

    //3.Refresh the picture in RAM to e-Paper
    epd.EPD_Display();    
#endif


  Dev->Dev_Delay_ms(15000);
   epd.EPD_Clear();
     epd.EPD_TurnOnDisplay(); 
    epd.EPD_Sleep();

}

void loop()
{

}
